import type {
  Express,
  Request,
  Response
} from "express";
import type { Pool } from 'mariadb';
import type { Controller } from '@slovo/api/controller';
import { UserRepository } from '@slovo/domain/repository/user-repository';

export class UserController implements Controller {
  private userRepository: UserRepository;

  public constructor(pool: Pool) {
    this.userRepository = new UserRepository(pool);
  }

  public bootstrapRoutes(app: Express): void {
    app.get('/users', this.getUsers);
    app.get('/user/:id', this.getUser);
    app.post('/user', this.createUser);
    app.put('/user', this.updateUser);
    app.put('/login', this.loginUser);
  }

  public async getUsers(req: Request, res: Response): Promise<Response> {
    const users = await this.userRepository.getAll();

    if (!users.size) {
      res.status(404);
    }

    return res.json({ users });
  }

  public async getUser(req: Request, res: Response): Promise<Response> {

    return res;
  }

  public async createUser(req: Request, res: Response): Promise<Response> {

    return res;
  }

  public async updateUser(req: Reqst, res: Response): Promise<Response> {

    return res;
  }

  public async loginUser(req: Request, res: Response): Promise<Response> {
    // match the passwords
    //
    // set the JWT data

    return res;
  }
}

