export type EntityId = number|string;

export class Entity<T> {
  protected readonly id: EntityId;
  protected _model: T;

  public constructor(id: EntityId, model: T) {
    this.id = id;
    this._model = model;
  }

  public getId(): EntityId {
    return this.id;
  }

  public getModel(): T {
    return this._model;
  }

  public get model(): T {
    return this.getModel();
  }
}
