import { type EntityId, Entity } from '@slovo/domain/entity';
import { BaseRepository } from '@slovo/domain/repository';
import { type Channel } from '@slovo/models/channel';

export class ChannelRepository extends BaseRepository<Channel> {
  public async get(id: EntityId): Promise<Entity<Channel>> {
    const conn = await this.pool.getConnection();
    const query = `SELECT * FROM Channels WHERE id = ?`;
    const rows = await conn.query(query, [ id ]);

    if (!rows.length) {
      throw Error("Unable to find Channel.");
    }

    return new Entity(id, { 
      name: rows[0].name,
      description: rows[0].description,
      link: new URL(rows[0].link),
      language: rows[0].language,
      copyright: rows[0].copyright,
      explicit: rows[0].explicit as boolean,
      category: rows[0].category,
    } as Channel);
  }

  public async save(channel: Entity<Channel>): Promise<Entity<Channel>> {

    return channel;
  }

  public async update(channel: Entity<Channel>): Promise<Entity<Channel>> {

    return channel;
  }

  public async delete(channel: Entity<Channel>): Promise<boolean> {
    return true;
  }
}
