import express, { 
  type Express,
  type Request,
  type Response
} from "express";
import connectionPool from '@slovo/infrastructure/connection-pool';

const server: Express = express();

// bootstrap controllers
import { UserController } from '@slovo/api/user-controller';
new UserController(connectionPool).bootstrapRoutes(server);

server.get("/", async (req: Request, res: Response) => {
  console.log(req);
  return res.json({ message: "Hello!" });
});

export { server };
